 ;Diretivas do jogo compilado 
 set tv ntsc
 set romsize 8k
 set optimization speed
 set optimization inlinerand
 set kernel_options playercolors player1colors pfcolors pfheights








 pfheights:
 8
 8
 8
 8
 8
 8
 8
 8
 8
 8
 8
end










_GameReset

 ;Limpar a tela 
 pfclear

 pfcolors:
 $06
 $08
 $0A
 $08
 $06
 $08
 $0A
 $08
 $06
 $08
 $0A
end

 ;Cor do score
 scorecolor=128 ;preto
 
 ;Inicializar o score 
 score=0

 ;Inicializar a barra de energia do player0
 statusbarlength=144 ;roxo 

 ;Posicao inicial do player
 player0x=71 : player0y=40
 player1x=146 : player1y=10

 ;Posicao inicial das estrela
 ballx=0 : bally=80

 ;Controle de tempo da rolagem dos blocos
 a=0 : dim frameBlocks=a
 
 ;Controle de tempo da animacao dos sprites
 b=0 : dim frameSprites=b

 ;Controle do level do jogo
 c=100 : dim level=c
 d=0 : dim cicleLevel=d

 ;Controla o inimigo da vez
 e=1 : dim enemiesTurn=e

 ;Controla o numero de ataques de cada inimigo
 f=1 : dim enemiesAttack=f

 ;Cor da barra de energia
 t=64 : dim statusbarcolor=t

 ;Assign a variable to the score background.
 u=6 : dim statusbarbackcolor=u




 ;Variavel auxiliar
 z=0 : dim auxiliar=z
 def bitBlockCollision=auxiliar{0} ;Indica a colisao do player0 com um bloco do playfield
 def bitEnemyMoveLR=auxiliar{1} ;Indica a direcao de movimentacao do player1 para left ou right 
 def bitEnemyMoveTB=auxiliar{2} ;Indica a direcao de movimentacao do player1 para top ou botton
 def bitEnemyRun=auxiliar{3} ;Inicia o ataque do player1

 def bitTrue=auxiliar{7} ;Variavel auxiliar para definir true e false para operacoes 








 
_Main

 ;Cor das barras 
 COLUPF=$06

 ;Cor de fundo 
 COLUBK=0

 ;Configuracao padrao dos players
 NUSIZ0=$00
 NUSIZ1=$00

 ;Reiniciar o jogo 
 if switchreset then goto _GameReset

 ;Incremento do level a cada ciclo
 if cicleLevel=10 then cicleLevel=0 : level=level-1

 if level<15 then level=25

 ;Contagem de tempo da animacao dos sprites  
 frameSprites=frameSprites+1
 if frameSprites>20 then frameSprites=0

 ;Apagar a primeira linha do playfield
 pfhline 0 0 31 off

 ;Desenhar o jogador
 if joy0down then gosub _DrawPlayer0Down
 if joy0up then gosub _DrawPlayer0Up
 if !joy0up && !joy0down then gosub _DrawPlayer0Normal

 ;Detectar o fim do jogo
 if statusbarlength<=4 then player0y=255 : player1y=255 : bally=255 : drawscreen : goto _Main

 ;Criar os blocos aleatorios e retirar um nivel de vida do jogador
 frameBlocks=frameBlocks+1
 if frameBlocks<>level then goto _SkipDrawBlocks

 ;Criar o bloco na posicao aleatoria
 temp4=(rand&31) : pfpixel temp4 11 on 

 ;Reinicar os ciclos para a criacao do proximo bloco
 frameBlocks=0 
 cicleLevel=cicleLevel+1 

 ;Diminuir a energia do player0
 statusbarlength=statusbarlength-4

 ;Contagem de pontos a cada bloco criado
 score=score+1

_SkipDrawBlocks

 ;Movimentacao do jogador na tela
 if joy0up && player0y>12 then player0y=player0y-1
 if joy0left then player0x=player0x-1
 if joy0down && player0y<85 then player0y=player0y+1
 if joy0right then player0x=player0x+1

 ;Movimentacao da jogador atraves das margens da tela
 if player0x<13 then player0x=142
 if player0x>142 then player0x=13

 ;Reposicionamento automatico do jogador
 if !joy0up && player0y<25 then if frameBlocks{0} then player0y=player0y+1
 if !joy0down && player0y>25 then if frameBlocks{0} then player0y=player0y-1

 ;Detectar a colisao do player0 com o player1 
 if collision(player0, player1) then gosub _DrawPlayer0Dying

 ;Se o jogador comeu a energia
 if collision(player0,playfield) then gosub _DrawPlayer0Eatting
 if bitBlockCollision then bitBlockCollision=0 : statusbarlength=statusbarlength+8 : score=score+5 : player0y=player0y+1
 ;Ajustar a barra de energia se ultrapassou o maximo 
 if statusbarlength>144 then statusbarlength=144

 ;Direcionar a frente do player1 para a direcao que ele esta indo
 if bitEnemyMoveLR then REFP1=8

 ;Movimentar os inimigos
 if enemiesTurn=1 then gosub _DrawAlien1 bank2 : gosub _MoveEnemy1
 if enemiesTurn=2 then gosub _DrawAlien2 bank2 : gosub _MoveEnemy2
 if enemiesTurn=3 then gosub _DrawAlien3 bank2 : gosub _MoveEnemy3
 if enemiesTurn=4 then gosub _DrawAlien4 bank2 : gosub _MoveEnemy4

 drawscreen 

 goto _Main



















_MoveEnemy1

 ;Iniciar a fuga do inimigo
 if bitEnemyRun then goto _MoveEnemy1Run

 ;Movimentar o inimigo na tela
 if bitEnemyMoveLR then temp4=10 else temp4=-10
 if player1y<10 || player1y>85 then bitEnemyMoveTB=!bitEnemyMoveTB : player1x=player1x+temp4 
 if bitEnemyMoveTB then player1y=player1y-1 else player1y=player1y+1

 ;Calcular o movimento do inimigo da esquerda para a direita ou da direita para a esquerda
 if player1x<13 || player1x>140 then bitEnemyMoveLR=!bitEnemyMoveLR : enemiesAttack=enemiesAttack+1

 ;Ajuste de posicionamento 
 if player1x<13 then player1x=13
 if player1x>140 then player1x=140

 ;Partir para o proximo inimigo
 if enemiesAttack>5 then bitEnemyRun=1 : goto _MoveEnemy1Run

 return 

_MoveEnemy1Run

 ;Movimentar fora da tela ate o proximo inimigo
 player1y=player1y+1
 
 ;Acionar o proximo inimigo e setar as propriedades iniciais da movimentacao
 if player1y=255 then bitEnemyRun=0 : enemiesAttack=1 : enemiesTurn=2 : bitEnemyMoveLR=1 : bitEnemyMoveTB=1 : player1x=13 : player1y=0

 return 



_MoveEnemy2

 ;Iniciar o attack do inimigo
 if bitEnemyRun then goto _MoveEnemy2Attack

 ;Movimentar o inimigo na tela da esquerda para a direita ou da direita para a esquerda
 if bitEnemyMoveLR then player1x=player1x+1 else player1x=player1x-1
 ;Movimentar o inimigo de cima para baixo ou de baixo para cima 
 if bitEnemyMoveTB then temp4=10 else temp4=-10
 if player1x<13 || player1x>143 then bitEnemyMoveLR=!bitEnemyMoveLR : player1y=player1y+temp4
 ;Ajuste de posicionamento 
 if player1y<10 then player1y=10
 if player1y>85 then player1y=85
 ;Acionar o attack do inimigo se ele ultrapassar os limites da tela
 if bitEnemyMoveTB then if player1y>70 && player1x=player0x then bitEnemyRun=1 : bitEnemyMoveTB=0
 if !bitEnemyMoveTB then if player1y<20 && player1x=player0x then bitEnemyRun=1 : bitEnemyMoveTB=1

 return 

_MoveEnemy2Attack

 ;Animacao de fuga do inimigo
 if bitEnemyMoveTB then player1y=player1y+1 else player1y=player1y-1

 ;Habilitar o retorno do inimigo e incrementar a quantidade de ataques 
 if player1y=125 then enemiesAttack=enemiesAttack+1 : goto _MoveEnemy2Back 

 return 
 
_MoveEnemy2Back 

 ;Cancelar fuga
 bitEnemyRun=0

 ;Partir para o proximo inimigo
 if enemiesAttack>5 then goto _MoveEnemy2Run
 
 ;Posicionar na tela para novo ataque
 if bitEnemyMoveTB then player1y=10 else player1y=85

 return

_MoveEnemy2Run

 ;Acionar o proximo inimigo e setar as propriedades iniciais da movimentacao
 enemiesAttack=1 : enemiesTurn=3 : bitEnemyMoveTB=0 : bitEnemyRun=0

 return 



_MoveEnemy3

 ;Iniciar o attack do inimigo
 if bitEnemyRun then goto _MoveEnemy3Attack

 ;Direcao de movimentacao do player0 para parear com a face do player1
 if joy0left then bitEnemyMoveLR=0
 if joy0right then bitEnemyMoveLR=1 

 ;Definir a posicao inicial de ataque
 if bitEnemyMoveTB then player1y=10 else player1y=85

 ;Ativar o ataque
 if cicleLevel=1 || cicleLevel=6 then bitEnemyRun=1 else player1x=player0x

 return 

_MoveEnemy3Attack

 ;Mergulhar para o ataque
 if bitEnemyMoveTB then player1y=player1y+1 else player1y=player1y-1

 ;Reiniciar para um novo ataque
 if player1y=125 then bitEnemyMoveTB=!bitEnemyMoveTB : bitEnemyRun=0 : enemiesAttack=enemiesAttack+1

 ;Partir para o proximo inimigo
 if enemiesAttack>10 then goto _MoveEnemy3Run

 return

_MoveEnemy3Run

 ;Acionar o proximo inimigo e setar as propriedades iniciais da movimentacao
 enemiesAttack=1 : enemiesTurn=4 : bitEnemyMoveLR=0 : bitEnemyRun=0 : player1x=13 : player1y=10


 return 



_MoveEnemy4

 ;Iniciar o attack do inimigo
 if bitEnemyRun then goto _MoveEnemy4Attack

 ;Definir a posicao inicial de ataque
 if bitEnemyMoveLR then player1x=13 else player1x=140

 ;Rastrear a posicao do player0
 if player0y<>player1y then if player0y>player1y then player1y=player1y+1
 if player0y<>player1y then if player0y<player1y then player1y=player1y-1

 ;Ativar o ataque
  if cicleLevel=1 || cicleLevel=6 then if player1y=player0y then bitEnemyRun=1 

 return 

_MoveEnemy4Attack

 ;Mergulhar para o ataque
 if bitEnemyMoveLR then player1x=player1x+1 else player1x=player1x-1

 ;Reiniciar para um novo ataque
 if player1x<10 || player1x>140 then bitEnemyMoveLR=!bitEnemyMoveLR : bitEnemyRun=0 : enemiesAttack=enemiesAttack+1

 ;Partir para o proximo inimigo
 if enemiesAttack>10 then goto _MoveEnemy4Run

 return

_MoveEnemy4Run

 ;Acionar o proximo inimigo e setar as propriedades iniciais da movimentacao
 enemiesAttack=1 : enemiesTurn=1 : bitEnemyMoveLR=0 : bitEnemyMoveTB=0 : player1x=140 : player1y=10

 return 










_DrawPlayer0Normal

 player0color:
 $DA
 $D8
 $D6
 $D6
 $D8
 $DA
 $DC
 $40
 $42
 $44
 $46
end

 if statusbarlength<=40 && frameSprites>10 then player0color:
 $4C
 $4A
 $48
 $48
 $4A
 $4C
 $4E
 $40
 $42
 $44
 $46
end

 if joy0left then goto _DrawPlayer0NormalLeft
 if joy0right then goto _DrawPlayer0NormalRight

 if frameSprites<=5 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
 %00000010
 %00101010
 %00101010
 %00001000
end
 if frameSprites>5 && frameSprites<=10 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
 %01000000
 %01000100
 %00010100
 %00010000
end
 if frameSprites>10 && frameSprites<=15 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
 %00000010
 %00100010
 %00101000
 %00001000
end
 if frameSprites>15 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
 %01000000
 %01010100
 %01010100
 %00010000
end
 return 

_DrawPlayer0NormalLeft
 if frameSprites<=5 then player0:
 %01111110
 %11111111
 %10110111
 %10110111
 %11111111
 %01111110
 %00111100
 %00000010
 %00101010
 %00101010
 %00001000
end
 if frameSprites>5 && frameSprites<=10 then player0:
 %01111110
 %11111111
 %10110111
 %10110111
 %11111111
 %01111110
 %00111100
 %01000000
 %01000100
 %00010100
 %00010000
end
 if frameSprites>10 && frameSprites<=15 then player0:
 %01111110
 %11111111
 %10110111
 %10110111
 %11111111
 %01111110
 %00111100
 %00000010
 %00100010
 %00101000
 %00001000
end
 if frameSprites>15 then player0:
 %01111110
 %11111111
 %10110111
 %10110111
 %11111111
 %01111110
 %00111100
 %01000000
 %01010100
 %01010100
 %00010000
end
 return 

_DrawPlayer0NormalRight 
 if frameSprites<=5 then player0:
 %01111110
 %11111111
 %11101101
 %11101101
 %11111111
 %01111110
 %00111100
 %00000010
 %00101010
 %00101010
 %00001000
end
 if frameSprites>5 && frameSprites<=10 then player0:
 %01111110
 %11111111
 %11101101
 %11101101
 %11111111
 %01111110
 %00111100
 %01000000
 %01000100
 %00010100
 %00010000
end
 if frameSprites>10 && frameSprites<=15 then player0:
 %01111110
 %11111111
 %11101101
 %11101101
 %11111111
 %01111110
 %00111100
 %00000010
 %00100010
 %00101000
 %00001000
end
 if frameSprites>15 then player0:
 %01111110
 %11111111
 %11101101
 %11101101
 %11111111
 %01111110
 %00111100
 %01000000
 %01010100
 %01010100
 %00010000
end
 return 



_DrawPlayer0Down

 player0color:
 $DC
 $DA
 $D6
 $D6
 $D6
 $D8
 $DA
 $DC
 $40
 $42
 $44
 $46
 $48
end

 if statusbarlength<=40 && frameSprites>10 then player0color:
 $4C
 $4C
 $4A
 $48
 $48
 $4A
 $4C
 $4E
 $40
 $42
 $44
 $46
end

 if frameSprites<=5 then player0:
 %00111100
 %01111110
 %11011011
 %11011011
 %11111111
 %11111111
 %01111110
 %00111100
 %00000010
 %00101010
 %00101010
 %00101010
 %00001000
end
 if frameSprites>5 && frameSprites<=10 then player0:
 %00111100
 %01111110
 %11011011
 %11011011
 %11111111
 %11111111
 %01111110
 %00111100
 %01000000
 %01000100
 %01010100
 %00010100
 %00010000
end
 if frameSprites>10 && frameSprites<=15 then player0:
 %00111100
 %01111110
 %11011011
 %11011011
 %11111111
 %11111111
 %01111110
 %00111100
 %00000010
 %00100010
 %00101010
 %00101000
 %00001000
end
 if frameSprites>15 then player0:
 %00111100
 %01111110
 %11011011
 %11011011
 %11111111
 %11111111
 %01111110
 %00111100
 %01000000
 %01010100
 %01010100
 %01010100
 %00010000
end
 return



_DrawPlayer0Up

 player0color:
 $DA
 $D8
 $D6
 $D8
 $DA
 $DC
 $40
 $42
 $44
end

 if statusbarlength<=40 && frameSprites>10 then player0color:
 $4C
 $4A
 $48
 $4A
 $4C
 $4E
 $40
 $42
 $44
end
 if frameSprites<=5 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %01111110
 %00111100
 %00000010
 %00101010
 %00001000
end
 if frameSprites>5 && frameSprites<=10 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %01111110
 %00111100
 %01000000
 %00000100
 %00010000
end
 if frameSprites>10 && frameSprites<=15 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %01111110
 %00111100
 %00000010
 %00100000
 %00001000
end
 if frameSprites>15 then player0:
 %01111110
 %11111111
 %11011011
 %11011011
 %01111110
 %00111100
 %01000000
 %01010100
 %00010000
end
 return 



_DrawPlayer0Eatting

 player0color:
 $D6
 $DA
 $D8
 $D6
 $D6
 $D6
 $D8
 $DA
 $DC
end

 player0:
 %00111100
 %01000010
 %11000011
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
end
 return



_DrawPlayer0Dying 

 ;Diminuir a energial do player0
 statusbarlength=statusbarlength-4

 if frameSprites{0} then player0color:
 $D6
 $4C
 $4A
 $48
 $46
 $46
 $48
 $4A
 $4C
end

 if !frameSprites{0} then player0color:
 $D6
 $D6
 $0E
 $0E
 $0E
 $0E
 $0E
 $0E
 $D6
end

 if frameSprites{0} then player0:
 %00000000
 %01111110
 %11111111
 %11111111
 %11011011
 %11011011
 %11111111
 %01111110
 %00111100
end
 if !frameSprites{0} then player0:
 %00000000
 %00000000
 %01111110
 %01111110
 %01011010
 %01011010
 %01111110
 %00111100
 %00000000
end
 return










 bank 2

_DrawAlien1

 player1color:
 $F6
 $F6
 $F6
 $F8
 $F6
 $F4
 $F6
 $F8
 $F2
end

 if frameSprites<=10 then player1:
 %01000100
 %10000010
 %01101100
 %11111110
 %11111111
 %10010011
 %10111011
 %01111110
 %00100100
end
 if frameSprites>10 then player1:
 %00101000
 %01000100
 %01101100
 %11111110
 %11111111
 %10010011
 %10111011
 %01111110
 %00100100
end
 return



_DrawAlien2

 player1color:
 $58
 $58
 $58
 $56
 $54
 $58
 $58
 $52
 $50
end

 if frameSprites<=10 then player1:
 %00100100
 %01000010
 %01000010
 %10011001
 %11111111
 %11010111
 %01010110
 %01111110
 %00111100
end
 if frameSprites>10 then player1:
 %01000010
 %01000010
 %10000001
 %10100101
 %11111111
 %11010111
 %01010110
 %01111110
 %00111100
end
 return



_DrawAlien3

 player1color:
 $16
 $18
 $1A
 $18
 $16
 $14
 $12
 $14
 $0E
 $0E
end

 if frameSprites<=10 then player1:
 %00111100
 %01000110
 %11111111
 %11111111
 %10101111
 %10101111
 %01111110
 %00111100
 %00100100
 %11000011
end
 if frameSprites>10 then player1:
 %00111100
 %01101110
 %11111111
 %11111111
 %10101111
 %10101111
 %01111110
 %00111100
 %10100101
 %01000010
end
 return


_DrawAlien4

 player1color:
 $F6
 $F6
 $E4
 $D4
 $C4
 $B4
 $A4
 $94
 $74
end

 if frameSprites<=10 then player1:
 %00000000
 %11100111
 %00111100
 %01100110
 %11111111
 %11010111
 %01010110
 %00111100
 %00011000
end
 if frameSprites>10 then player1:
 %01000010
 %01100110
 %00111100
 %01100110
 %11111111
 %11010111
 %01010110
 %00111100
 %00011000
end
 return









 ;Detectar a colisao do jogador com os blocos do playfield 
_DetectBlockCollision

 ;Calcular a busca do raio baseado na posicao x,y central do jogador
 temp5=(player0y-4)/8 
 if frameBlocks{0} then temp4=(player0x-12)/4 else temp4=(player0x-16)/4

 ;Detectar raio alinhado ao centro do player0
 if pfread(temp4,temp5) then pfpixel temp4 temp5 off : bitBlockCollision=1

 return 










 vblank

 ;Se houver colisao do jogador com raios na tela
 if collision(player0, playfield) then gosub _DetectBlockCollision bank2 

 ;Rolagem dos blocos
 pfscroll up

 ;Estrelas
 if statusbarlength<=4 then goto _SkipDrawStars
 if bally>200 then bally=80
 ballx=(rand&127)+10 
 if frameBlocks{0} then bally=bally+5 else bally=bally-10
_SkipDrawStars

 return





 inline statusbar.asm

